unit CopyHk;

interface

uses
  Windows, ActiveX, ComObj, ShlObj;

type
  TCopyHook = class(TComObject, ICopyHook)
  public
    function CopyCallback(Wnd: HWND; wFunc, wFlags: UINT; pszSrcFile: PWideChar;
      dwSrcAttribs: DWORD; pszDestFile: PWideChar; dwDestAttribs: DWORD): UINT; stdcall;
  end;

const
  Class_CopyHook: TGUID = '{29F97553-FBD6-11D1-AFC1-00A024D1875C}';

implementation

uses ComServ, ShellAPI, SysUtils, Registry;

function TCopyHook.CopyCallBack(Wnd: HWND; wFunc, wFlags: UINT;
  pszSrcFile: PWideChar; dwSrcAttribs: DWORD; pszDestFile: PWideChar;
  dwDestAttribs: DWORD): UINT;
var
  Operation  : String;
  SrcFile    : String;
  TargetFile : String;
  MstStr     : String;
begin
  TargetFile := UpperCase('D:\000');
  SrcFile    := UpperCase(String(pszSrcFile));

  if Pos(TargetFile, SrcFile) > 0 then begin
    MstStr := String(pszSrcFile) + sLineBreak +
              '̃tH_ɑ΂鑀͋Ă܂';
    MessageBox(Wnd, PChar(MstStr), 'VFRs[tbN' , MB_OK);
    Result := IDNO;
  end else begin
    case wFunc of
      FO_COPY:
        Operation := 'Rs[';
      FO_DELETE:
        Operation := '폜';
      FO_MOVE:
        Operation := 'ړ';
      FO_RENAME:
        Operation := 'O̕ύX';
      else
        Operation := ''
    end;

    MstStr := Operation + sLineBreak +
              String(pszSrcFile) + sLineBreak +
              '𑱍s܂ ? ';
    Result := MessageBox(Wnd, PChar(MstStr), 'VFRs[tbN' , MB_YESNOCANCEL);
  end;
end;

type
  TCopyHookFactory = class(TComObjectFactory)
  public
    procedure UpdateRegistry(Register: Boolean); override;
  end;

procedure TCopyHookFactory.UpdateRegistry(Register: Boolean);
var
  ClassID: string;
begin
  if Register then begin
    inherited UpdateRegistry(Register);

    ClassID := GUIDToString(Class_CopyHook);
    CreateRegKey('Directory\shellex\CopyHookHandlers\DelphiCopyHook', '', ClassID);
    if (Win32Platform = VER_PLATFORM_WIN32_NT) then
      with TRegistry.Create do
        try
          RootKey := HKEY_LOCAL_MACHINE;
          OpenKey('SOFTWARE\Microsoft\Windows\CurrentVersion\Shell Extensions', True);
          OpenKey('Approved', True);
          WriteString(ClassID, 'Delphi CopyHook Shell Extension Example');
        finally
          Free;
        end;
  end
  else begin
    DeleteRegKey('Directory\shellex\CopyHookHandlers\DelphiCopyHook');

    inherited UpdateRegistry(Register);
  end;
end;

initialization
  TCopyHookFactory.Create(ComServer, TCopyHook, Class_CopyHook, '',
    'Delphi CopyHook Shell Extension Example', ciMultiInstance, tmApartment);
end.
